import _ from 'lodash';

export default (identifierNode, context) => {
    if (_.has(identifierNode, 'name')) {
        return identifierNode.name;
    }

    if (_.has(identifierNode, 'left.name')) {
        return identifierNode.left.name;
    }

    if (identifierNode.type === 'RestElement') {
        return identifierNode.argument.name;
    }

    if (identifierNode.type === 'ObjectPattern') {
        return context.getSourceCode().getText(identifierNode);
    }

    console.log('identifierNode', identifierNode.type);

    throw new Error('Unsupported function signature.');
};
